#include <stdio.h>
#include <windows.h>
#include <process.h> // thread

// for freeGL (OpenGL Library GLUT compatible)
#include "freeglut/freeglut_std.h"
//#pragma comment(lib,"freeglut_static.lib")

#define MAIN_WINDOW_TOP    40
#define MAIN_WINDOW_LEFT   500
#define MAIN_WINDOW_WIDTH  640
#define MAIN_WINDOW_HEIGHT 480

float Yaw =0 , Roll = 0 , Pitch = 0, YawOfs = 0;

extern void CommandKey(int key);

void display_process(){
	int w, h;
	float focus_depth=5;
	float teapot_dest=9;
	float teapot_size=2;
	float vec1[4],vec2[4];
	float pot_color;
	float col;
	
	char buf[1024];
	int n;
	int lr;
	
	col=1;
	
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	w=glutGet(GLUT_WINDOW_WIDTH); h=glutGet(GLUT_WINDOW_HEIGHT);

	for (lr=0;lr<2;lr++) {
	
	if (lr==0) {
		glViewport(0,(h-w/2)/2,w/2,w/2);
	} else {
		glViewport(w/2+1,(h-w/2)/2,w/2,w/2);
	}

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluOrtho2D(-1,1,-1,1);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	glDisable(GL_LIGHT0);
	
	//wi`
	glDisable(GL_DEPTH_TEST);
	  glBegin(GL_POLYGON);
	  glColor3f(0.7,0.7,1);	glVertex2f(-1,1);
	  glColor3f(0.7,0.7,1);	glVertex2f(1,1);
	  glColor3f(1,1,1);	glVertex2f(1,-1);
	  glColor3f(1,1,1);	glVertex2f(-1,-1);
	glEnd();

	glEnable(GL_DEPTH_TEST);

	//eݒ
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(45,w/h,1,5000);
	glMatrixMode(GL_MODELVIEW);

	//Jʒuݒ
	glLoadIdentity();
	if (lr==0) {
		gluLookAt( 0.5, 0,-teapot_dest,0,0,focus_depth-teapot_dest,0,1,0);
	} else {
		gluLookAt(-0.5, 0,-teapot_dest,0,0,focus_depth-teapot_dest,0,1,0);
	}
	
	//eB[|bg`
	{
		float direction;
		float direction2;
		direction = YawOfs;
		glRotatef( direction , 0,1,0);
		
		// yaw,roll,pitch3̉]pCG]
		glRotatef ((GLfloat) Yaw, 0, -1, 0);
		glRotatef ((GLfloat) Roll, 0,  0, 1);
		glRotatef (-(GLfloat) Pitch, 1,  0, 0);
		
		direction2 = +270.0;
		glRotatef( direction2 , 0,1,0);
		pot_color=col;
	}
	glColor3f(1,0,0);
	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);
	  vec1[0]=vec1[1]=vec1[2]=vec1[3]=1;
	  glMaterialfv(GL_FRONT_AND_BACK,GL_DIFFUSE,vec1);
	  vec2[0]=vec2[1]=0.5; vec2[2]=vec2[3]=pot_color;
	  glLightfv(GL_LIGHT0,GL_DIFFUSE,vec2);
	  glutSolidTeapot(teapot_size);				// eB[|bg\!!
	glDisable(GL_LIGHTING);
	glDisable(GL_LIGHT0);
	glLoadIdentity();
	}
	
	glutSwapBuffers(); //Flip
}

void reshape_process(int w,int h)
{
	display_process();
}

void animation_process()
{
	Sleep(10); glutPostRedisplay();
	Yaw   += 0.15;
	Roll  += 0.25;
	Pitch += 0.35;
}

void keyboard_process(unsigned char c,int x,int y)
{
	c=toupper(c);
	if (c==0x1B) { exit(1); }
}

void mouse_button(int button,int state,int x,int y) {}
void mouse_move(int x,int y) {}
void quitproc() {}

void OpenGL_Main(void *)
{
	int argc=1;
	char *argv[2];
	argv[0]="teapot"; argv[1]=NULL;
	glutInit(&argc,argv);
	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
	glutInitWindowPosition(MAIN_WINDOW_LEFT,MAIN_WINDOW_TOP);
	glutInitWindowSize(MAIN_WINDOW_WIDTH,MAIN_WINDOW_HEIGHT);
	glutCreateWindow("teapot");
	glutDisplayFunc(display_process);
	glutKeyboardFunc(keyboard_process);
	glutReshapeFunc(reshape_process);
	glutMouseFunc(mouse_button);
	glutMotionFunc(mouse_move);
	glutIdleFunc(animation_process);
	glClearColor(0,0,0,0);
	glEnable(GL_DEPTH_TEST);
	
	glutFullScreen();
	
	glutMainLoop();
}

int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,LPSTR lpCmdLine, int nCmdShow )
{
	HANDLE hMutex;

	//2dN̖h~
	hMutex = CreateMutex(NULL, TRUE, "addon-001");
	if (!hMutex) { return FALSE; }
	if (GetLastError() == ERROR_ALREADY_EXISTS) {
		return FALSE; //2dNꍇ I
	}
	OpenGL_Main(NULL);
	return 0;
}
